leetcode-300-Longest Increasing Subsequence

来源:互联网 发布:u盘数据恢复破解版 编辑:程序博客网 时间:2024/04/29 19:43

题目:Longest Increasing Subsequence 最长升序子序列

Given an unsorted array of integers, find the length of longest increasing subsequence.

For example,

Given [10, 9, 2, 5, 3, 7, 101, 18],

The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?

简单的O(n2)时间复杂度的DP算法:

dp[i]为以nums[i]为结尾的最长升序子序列的长度,nums序列的最长升序子序列长度为max(dp[i]) (0<=i<n)

每次将所有nums[j](j<i)与nums[i]比较,if nums[j]<nums[i], dp[i] = max(dp[j]+1, dp[i]),意思是以nums[j]结尾的升序序列长度可以+1,dp[i]的长度就是dp[j+1]中最长的那个。

代码如下:

class Solution {public:    //o(n^2)    int lengthOfLIS(vector<int>& nums) {        int size = nums.size(), res = 0;        if(size == 0 || size == 1) return size;        vector<int> dp(size,1);        for(int i = 1; i < size; i ++){            for(int j = 0; j < i; j ++){                if(nums[j] < nums[i]){                    dp[i] = max(dp[j]+1, dp[i]);                }            }            res = max(res,dp[i]);        }        return res;    }};

O(nlogn)的方法,参考别人的代码好久思考了好久,这里设置一个tail[],tail[i]保存长度为i+1的升序子串的tai值(最后一个数)。

当nums[i]<tail[0]时,tail[0]=nums[i]

当nums[i]>tail[tail.size()-1]时,tail[tail.size()]=nums[i]

else,找到当前tail中比nums[i]大的最小的一个数tail[res],tail[res]=nums[i]。意思是更新一下长度为res的升序子串的最后一个数,将更小的数nums[i]替换掉原来的数。

// NLogN solution from geek for geekint lengthOfLIS(vector<int>& nums) {    if (nums.empty()) { return 0; }     vector<int> tail;  // keep tail value of each possible len    tail.push_back(nums[0]);    for (auto n : nums) {        if (n <= tail[0]) {            tail[0] = n;        } else if (n > tail.back()) { // large than the tail of current largest len             tail.push_back(n);        } else {  // find smallest one which is >= n            int left = 0;             int right = tail.size()-1;            int res = left;            while(left <= right) {                int mid = left + (right-left)/2;                if (tail[mid] >= n) {                    res = mid;                    right = mid-1;                } else { // tail[mid] < n                    left = mid+1;                }            }            tail[res] = n;        }    }    return tail.size();}


0 0
原创粉丝点击